---
title: Player paddle and controls
slug: Games/Tutorials/2D_breakout_game_Phaser/Player_paddle_and_controls
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Bounce_off_the_walls", "Games/Workflows/2D_Breakout_game_Phaser/Game_over")}}</p>

<div class="summary">
<p>This is the <strong>7th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson07.html">Gamedev-Phaser-Content-Kit/demos/lesson07.html</a>.</p>
</div>

<p><span class="seoSummary">We have the ball moving and bouncing off the walls, but it quickly gets boring — there's no interactivity! We need a way to introduce gameplay, so in this article we'll create a paddle to move around and hit the ball with.</span></p>

<h2 id="Rendering_the_paddle">Rendering the paddle</h2>

<p>From the framework point of view the paddle is very similar to the ball — we need to add a variable to represent it, load the relevant image asset, and then do the magic.</p>

<h3 id="Loading_the_paddle">Loading the paddle</h3>

<p>First, add the <code>paddle</code> variable we will be using in our game, right after the <code>ball</code> variable:</p>

<pre class="brush: js notranslate">var paddle;
</pre>

<p>Then, in the <code>preload</code> function, load the <code>paddle</code> image by adding the following new <code>load.image()</code> call:</p>

<pre class="brush: js notranslate">function preload() {
    // ...
    game.load.image('ball', 'img/ball.png');
    game.load.image('paddle', 'img/paddle.png');
}
</pre>

<h3 id="Adding_the_paddle_graphic">Adding the paddle graphic</h3>

<p>Just so we don't forget, at this point you should grab the <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/img/paddle.png">paddle graphic </a>from Github, and save it in your <code>/img</code> folder.</p>

<h3 id="Rendering_the_paddle_with_physics">Rendering the paddle, with physics</h3>

<p>Next up, we will init our paddle by adding the following <code>add.sprite()</code> call inside the <code>create()</code> function — add it right at the bottom:</p>

<pre class="brush: js notranslate">paddle = game.add.sprite(game.world.width*0.5, game.world.height-5, 'paddle');
</pre>

<p>We can use the <code>world.width</code> and <code>world.height</code> values to position the paddle exactly where we want it: <code>game.world.width*0.5</code> will be right in the middle of the screen. In our case the world is the same as the Canvas, but for other types of games, like side-scrollers for example, the world will be bigger, and you can tinker with it to create interesting effects.</p>

<p>As you'll notice if you reload your <code>index.html</code> at this point, the paddle is currently not exactly in the middle. Why? Because the anchor from which the position is calculated always starts from the top left edge of the object. We can change that to have the anchor in the middle of the paddle's width and at the bottom of it's height, so it's easier to position it against the bottom edge. Add the following line below the previous new one:</p>

<pre class="brush: js notranslate">paddle.anchor.set(0.5,1);
</pre>

<p>The paddle is now positioned right where we want it to be. Now, to make it collide with the ball we have to enable physics for the paddle. Continue by adding the following new line, again at the bottom of the <code>create()</code> function:</p>

<pre class="brush: js notranslate">game.physics.enable(paddle, Phaser.Physics.ARCADE);
</pre>

<p>Now the magic can start to happen — the framework can take care of checking the collision detection on every frame. To enable collision detection between the paddle and ball, add the <code>collide()</code> method to the <code>update()</code> function as shown:</p>

<pre class="brush: js notranslate">function update() {
    game.physics.arcade.collide(ball, paddle);
}
</pre>

<p>The first parameter is one of the objects we are interested in — the ball — and the second is the other one, the paddle. This works, but not quite as we expected it to — when the ball hits the paddle, the paddle falls off the screen! All we want is the ball bouncing off the paddle and the paddle staying in the same place. We can set the <code>body</code> of the paddle to be <code>immovable</code>, so it won't move when the ball hits it. To do this, add the below line at the bottom of the <code>create()</code> function:</p>

<pre class="brush: js notranslate">paddle.body.immovable = true;
</pre>

<p>Now it works as expected.</p>

<h2 id="Controlling_the_paddle">Controlling the paddle</h2>

<p>The next problem is that we can't move the paddle. To do that we can use the system's default input (mouse or touch, depending on platform) and set the paddle position to where the <code>input</code> position is. Add the following new line to the <code>update()</code> function, as shown:</p>

<pre class="brush: js notranslate">function update() {
    game.physics.arcade.collide(ball, paddle);
    paddle.x = game.input.x;
}
</pre>

<p>Now on every new frame the paddle's <code>x</code> position will adjust accordingly to the input's <code>x</code> position, however when we start the game, the position of the paddle is not in the middle. It's because the input position is not yet defined. To fix that we can set the default position (if an input position is not yet defined) to be the middle of the screen. Update the previous line as follows:</p>

<pre class="brush: js notranslate">paddle.x = game.input.x || game.world.width*0.5;
</pre>

<p>If you haven't already done so, reload your <code>index.html</code> and try it out!</p>

<h2 id="Position_the_ball">Position the ball</h2>

<p>We have the paddle working as expected, so let's position the ball on it. It's very similar to positioning the paddle — we need to have it placed in the middle of the screen horizontally and at the bottom vertically with a little offset from the bottom. To place it exactly as we want it we will set the anchor to the exact middle of the ball. Find the existing <code>ball <span class="keyword operator">=</span> game.add.</code><span class="call function"><code>sprite( ... )</code> line, and replace it with the following two lines:</span></p>

<pre class="brush: js notranslate">ball = game.add.sprite(game.world.width*0.5, game.world.height-25, 'ball');
ball.anchor.set(0.5);</pre>

<p>The velocity stays almost the same — we're just changing the second parameter's value from 150 to -150, so the ball will start the game by moving up instead of down. Find the existing <code>ball.body.velocity.set( ... )</code> line and update it to the following:</p>

<pre class="brush: js notranslate">ball.body.velocity.set(150, -150);
</pre>

<p>Now the ball will start right from the middle of the paddle.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/ogqza0ye/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>We can move the paddle and bounce the ball off it, but what's the point if the ball is bouncing off the bottom edge of the screen anyway? Let's introduce the possibility of losing — also known as <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Game_over">game over</a> logic.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Bounce_off_the_walls", "Games/Workflows/2D_Breakout_game_Phaser/Game_over")}}</p>
